#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <math.h>
#include <XRS/Simple.h>
#include <XRS/Control.h>
using namespace XRS;
#include "include/Cell.h"


#define PI M_PI        // ߼Ψ
#define MAX(x,y)  ((x>y)?(x):(y))
#define MIN(x,y)  ((x<y)?(x):(y))


/****************************************************
                ѿؿ
****************************************************/

double   dt;                // ֹ
double   b=0.25;            // ߺѤΥѥ᡼

double   Q=0.1,T=1.0;      // Ǯѥ᡼겹 
double   xi;               // MD񹳷
double   K;                // (γαưͥ륮)

double   t;                 // 
double   L;                 // ƥॵ
int      N0;                // γҿ 
int      N;                 // γҿ
int      M;                 // xyθѤγʻҤο (L>M)

int      mag;               // ɽΨ
void     init(int);         // γҤν
void     interaction(void); // γҤƯϤη׻
void     plot(int);         // 


/****************************************************
	      γ
****************************************************/

class Particle;           
Lattice<Particle>  cell;   // γҸѤγʻ

class Particle
{  
 private:
   double fx0,fy0,vx0,vy0;   // ư򤯤ΰѿ
   int    i,j,n;             // ʻֹ¸뤿ѿ

 public:
   double x,y;       // ɸ
   double fx,fy;     //  (fx,fy)
   double vx,vy;     // ®
   double dx,dy;     // ɸ (x,y)1֥ƥåפˤĤƤʬ    

   Particle():fx0(0),fy0(0),vx0(0),vy0(0),x(0),y(0),
              fx(0),fy(0),vx(0),vy(0),dx(0),dy(0){}; 

   void init(double x0,double y0,double v,double deg){
     x=x0; y=y0; vx=v*cos(deg); vy=v*sin(deg); vx0=vy0=fx=fx0=fy=fy0=0; 
   }

   void   move(void);                     // 1ƥåפǤγҤαư 
   double v2(void){return vx*vx+vy*vy;}   // 1ƥåפǤγҤαư 
   inline void set(int ii, int jj,int nn){ i=ii; j=jj; n=nn;}  
   inline int Li(){ return i; }
   inline int Lj(){ return j; }
   inline int Ln(){ return n; }
};


//  1ƥåפǤγҤαư 
void Particle::move(void)                    
{
     double dt2=dt*0.5, dt3=dt*1.5;

     // ¿
     vx+=fx*dt3-fx0*dt2;   dx=(vx+vx0)*dt2;   vx0=vx;   fx0=fx;  
     vy+=fy*dt3-fy0*dt2;   dy=(vy+vy0)*dt2;   vy0=vy;   fy0=fy;   
     x=x+dx; y=y+dy;
  
    // 
     if(x>L) x-=L;  else if(x<0) x+=L; 
     if(y>L) y-=L;  else if(y<0) y+=L; 
} 

Particle  *P=NULL;        // γ



/*******************************************************
                   ᥤ 
*******************************************************/

int main(int argc,char **argv)
{
  if(argc>1) L=atof(argv[1]);  else L=5;
  if(argc>2) dt=atof(argv[2]); else dt=0.001;

  mag=int(500/L);            // ̤Υ 500x500 Ȥ롣  
  N0=int(L*L*10);
  M=(int)L;

  init(0);                   // γҤν

  while(1){
    plot(0);                 // 
    interaction();           // γҤƯϤη׻

    K=0;
    for(int n=0; n<N; n++) 
     { P[n].move(); cell.add(n); K+=P[n].v2(); } // 1ƥåפλȯŸ
    K/=2*N;                      

    xi+=dt*(K-T)*(2.0*N-1.0)/Q; // MD 񹳷Ĵ
    t+=dt;
  } 
}


/*********************************************************
                  γҤν 
*********************************************************/
   
void init(int)
{
  //============ ν ===================

  N=N0;
  if(P!=NULL){ delete [] P; P=NULL; }
  P=new Particle [N]; 
  cell.init(P,0,L,0,L,M,M); 


  //============  ֤ ====================

  double v0=sqrt(T);
  double x0,y0,xx,yy;
  int    find,failcount;

  for(int nn=0; nn<N; nn++){

    failcount=0;
    do{
      x0=L*drand48();  y0=L*drand48();  find=1;
      for(int k=0; k<nn; k++){
        xx=P[k].x-x0; yy=P[k].y-y0;
        if(xx*xx+yy*yy<0.25*b*b){ failcount++; find=0; break;}
      }
      if(failcount>1000000){ break; }
    }while(!find);
    
    if(!find){ 
	fprintf(stderr,
         "can not find an initial state. Change N to %d\n",nn);
        N=nn; break; 
    } 

    P[nn].init(x0,y0,v0,2.0*M_PI*drand48());
    cell.add(nn);
  }     



  //=========  롼ν =================

  xi=0;
  t=0;        // ֤0ˤ롣

  plot(1);                 
}



/**********************************************************
             γҤƯ
**********************************************************/

void interaction(void)
{
  int i,j;
   void   actf(int,int); // ܿȽܿϤη׻ 

   //=========  ================
   for(int n=0; n<N; n++){  P[n].fx=-xi*P[n].vx;  P[n].fy=-xi*P[n].vy;  }

   //========= դγҤȤߺ ================
   for(int n=0; n<N; n++){
     int lyn=cell.Lj(P[n].y)-1, lyp=cell.Lj(P[n].y)+2;
     int lxn=cell.Li(P[n].x)-1, lxp=cell.Li(P[n].x)+2;

     for(int ly=lyn; ly<lyp; ly++)
       for(int lx=lxn; lx<lxp; lx++){
         i=lx; j=ly;
         if(i<0) i+=M; else if(i>=M) j-=M;
         if(j<0) j+=M; else if(j>=M) j-=M;
         for(int m=cell.first(i,j); m!=-1; m=cell.next()){
            if(m>n) actf(n,m);
         }
       }
   }
}


/*******************************************************
              ܿȽܿϤη׻ 
********************************************************/

void actf(int i,int j)
{
    if(i==j) return;

    //================ ܿȽ =================

    double xx=P[j].x-P[i].x,   yy=P[j].y-P[i].y;

    if(xx+xx> L) xx-=L;
    if(xx+xx<-L) xx+=L;
    if(yy+yy> L) yy-=L;
    if(yy+yy<-L) yy+=L;
    double R2=xx*xx+yy*yy;

    if(R2>1.0){ return; }  //ܿƤʤ

    //======= Ѱ̡®٤η׻ ======== 
    double R=sqrt(R2);
    double f,fx,fy;

    //f=(R-1.0)*(R-1.0)*(R-b)/R;

    /* ݥƥ󥷥 U(R)=(R-1)*(R-1)*(b-R)/R */
    f=-(R-1.0)*(2.0*R*R-b*R-b)/R;  
    fx=f*xx/R2;  fy=f*yy/R2;

    if(R<0.01*b) fprintf(stderr,"Error\n");

    // γҤ˲äϤη׻
    P[i].fx+=fx;      P[j].fx-=fx;
    P[i].fy+=fy;      P[j].fy-=fy;
}


/*******************************************************
             եå
********************************************************/

Simple_Window Win,TWin;
Control_Window CW,CWT(TWin);
Display  *d=Win.disp();
GC       gc0=graphic_context("blue");
GC       gc1=graphic_context("red");
GC       white=graphic_context("white");
GC       black=graphic_context("black");
double   Tamp=0.7;
int      width,Twidth=300,Theight=400,pr=6,dispstep=10;

#define  TJ(y)  int(Theight*(1.0-Tamp*(y)))


void change_plot(int)
{
  Control_Window PW;
  PW.realtime=0;  f_dialog close(PW);  close.title("close");  PW.realtime=1;
  PW.redraw();
  PW.title("plot parameter");

  PW<<PARAMETER
    <<Tamp<<"Tamp"<<dispstep<<"dispstep"<<pr<<"pr";
  while(!(PW.chev && close.chev)) checkevent(); 

  Win.clear();
}


void plot(int reset)
{
  static int initial=-1, count=0, Ti=0, Tj0=0;
  static int *i=NULL,*j=NULL;
  int        Tj;

  if(initial<0){
    width=int(L*mag);
    CW.title("parameters");
    CW<<t<<"t"<<init<<"initial"<<change_plot<<"view"
      <<PARAMETER<<N0<<"N"<<b<<"b"<<Q<<"Q"<<dt<<"dt";

    CWT<<PARAMETER<<T<<"T";

    Win.geometry(width,width)<<"snapshot";
    TWin.geometry(Twidth,Theight)<<"temerature";
    initialize();     
    initial=0;
  }

  if(reset){
    Win.clear();
    if(i!=NULL){ delete [] i; } i=new int [N]; 
    if(j!=NULL){ delete [] j; } j=new int [N]; 
  }
  
  checkevent();

  if(count%dispstep==0){

    for(int n=0; n<N; n++){
      XFillArc(d,Win,white,i[n],j[n],pr,pr,0,23040);
      i[n]=int(mag*P[n].x);
      j[n]=int(mag*(L-P[n].y));
      XFillArc(d,Win,gc0,i[n],j[n],pr,pr,0,23040);
    }
    
    Tj=TJ(K);
    XDrawLine(d,TWin,gc1,Ti,Tj0,Ti+1,Tj);
    Tj0=Tj;     
    Ti++; if(Ti>Twidth){TWin.clear(); Ti=0;}

    count=0;
  }

  count++;
}
