#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <math.h>
#include <XRS/Simple.h>
#include <XRS/Control.h>
using namespace XRS;
#include "include/Cell.h"

#define PI M_PI        // ߼Ψ
#define MAX(x,y)  ((x>y)?(x):(y))
#define MIN(x,y)  ((x<y)?(x):(y))


/****************************************************
                ѿؿ
****************************************************/

double   dt;                // ֹ
double   r=1.0;             // γҤȾ
double   rb=20;             // Borwn γҤȾ
double   a=1.0, b=10.0;     // ߺѤΥѥ᡼(r,rb>a)
double   mb=10000.0;         // Borwn γҤμ

double   Q=1.0,T=1.0;       // Ǯѥ᡼겹 
double   xi;                // MD񹳷
double   K;                 // (γαưͥ륮)

double   t;                 // 
double   L;                 // ƥॵ
int      N0;                // γҿ 
int      N;                 // γҿ
int      M;                 // xyθѤγʻҤο (L>M*(2*r))

void     init(int);         // γҤν
void     interaction(void); // γҤƯϤη׻
void     plot(int);         // 


/****************************************************
	      γ
****************************************************/

class Particle;           
Lattice<Particle>  cell;   // γҸѤγʻ

class Particle
{  
 private:
   double fx0,fy0,vx0,vy0;   // ư򤯤ΰѿ
   int    i,j,n;             // ʻֹ¸뤿ѿ

 public:
   double x,y;       // ɸ
   double fx,fy;     //  (fx,fy)
   double vx,vy;     // ®
   double dx,dy;     // ɸ (x,y)1֥ƥåפˤĤƤʬ    

   Particle():fx0(0),fy0(0),vx0(0),vy0(0),x(0),y(0),
              fx(0),fy(0),vx(0),vy(0),dx(0),dy(0){}; 

   void init(double x0,double y0,double v,double deg){
     x=x0; y=y0; vx=v*cos(deg); vy=v*sin(deg); vx0=vy0=fx=fx0=fy=fy0=0; 
   }

   void   move(void);                     // 1ƥåפǤγҤαư 
   double v2(void){return vx*vx+vy*vy;}   // 1ƥåפǤγҤαư 
   inline void set(int ii, int jj,int nn){ i=ii; j=jj; n=nn;}  
   inline int Li(){ return i; }
   inline int Lj(){ return j; }
   inline int Ln(){ return n; }
};


//  1ƥåפǤγҤαư 
void Particle::move(void)                    
{
  double dt2=dt*0.5, dt3=dt*1.5;

     // ¿
  vx+=fx*dt3-fx0*dt2;   dx=(vx+vx0)*dt2;   vx0=vx;   fx0=fx;  
  vy+=fy*dt3-fy0*dt2;   dy=(vy+vy0)*dt2;   vy0=vy;   fy0=fy;   
  x=x+dx; y=y+dy;

    // ȿͶ
  if     (x>L-r){ x=2.0*(L-r)-x; vx=-vx; vx0=-vx0; dx=-dx; fx=-fx; fx0=-fx0;}
  else if(x<r)  { x=2.0*r-x;     vx=-vx; vx0=-vx0; dx=-dx; fx=-fx; fx0=-fx0;}
  if     (y>L-r){ y=2.0*(L-r)-y; vy=-vy; vy0=-vy0; dy=-dy; fy=-fy; fy0=-fy0;}
  else if(y<r)  { y=2.0*r-y;     vy=-vy; vy0=-vy0; dy=-dy; fy=-fy; fy0=-fy0;}

} 


class BrownParticle
{  
 private:
   double fx0,fy0,vx0,vy0;   // ư򤯤ΰѿ

 public:
   double x,y;       // ɸ
   double fx,fy;     //  (fx,fy)
   double vx,vy;     // ®
   double dx,dy;     // ɸ (x,y)1֥ƥåפˤĤƤʬ    

   BrownParticle():fx0(0),fy0(0),vx0(0),vy0(0),x(0),y(0),
                   fx(0),fy(0),vx(0),vy(0),dx(0),dy(0){}; 

   void init(double x0,double y0){ x=x0; y=y0;}

   void   move(void);                     // 1ƥåפǤγҤαư 
};


//  1ƥåפǤγҤαư 
void BrownParticle::move(void)                    
{
  double dt2=dt*0.5, dt3=dt*1.5;

  // ¿
  vx+=(fx*dt3-fx0*dt2)/mb;   dx=(vx+vx0)*dt2;   vx0=vx;   fx0=fx;  
  vy+=(fy*dt3-fy0*dt2)/mb;   dy=(vy+vy0)*dt2;   vy0=vy;   fy0=fy;   
  x=x+dx; y=y+dy;

    // ȿͶ
  if     (x>L-rb){ x=2.0*(L-rb)-x; vx=-vx; vx0=-vx0; dx=-dx; fx=-fx; fx0=-fx0;}
  else if(x<rb)  { x=2.0*rb-x;     vx=-vx; vx0=-vx0; dx=-dx; fx=-fx; fx0=-fx0;}
  if     (y>L-rb){ y=2.0*(L-rb)-y; vy=-vy; vy0=-vy0; dy=-dy; fy=-fy; fy0=-fy0;}
  else if(y<rb)  { y=2.0*rb-y;     vy=-vy; vy0=-vy0; dy=-dy; fy=-fy; fy0=-fy0;}
} 


Particle      *P=NULL;   // γ
BrownParticle  B;        // Brownγ



/*******************************************************
                   ᥤ 
*******************************************************/

int main(int argc,char **argv)
{
  if(argc>1) N0=atoi(argv[1]); else N0=150;
  if(argc>2) L=atof(argv[2]);  else L=200;
  if(argc>3) dt=atof(argv[3]); else dt=0.001;

  M=(int)(L/(2.0*r));

  init(0);                   // γҤν

  while(1){
    plot(0);                 // 
    interaction();           // γҤƯϤη׻

    K=0;
    for(int n=0; n<N; n++) 
    { P[n].move(); cell.add(n); K+=P[n].v2();  B.move(); 
    } // 1ƥåפλȯŸ
    K/=2*N;                      

    xi+=dt*(K-T)*(2.0*N-1.0)/Q; // MD 񹳷Ĵ
    t+=dt;
  } 
}


/*********************************************************
                  γҤν 
*********************************************************/
   
void init(int)
{
  //============ ν ===================

  N=N0;
  if(P!=NULL){ delete [] P; P=NULL; }
  P=new Particle [N]; 
  cell.init(P,0,L,0,L,M,M); 


  //============  ֤ ====================

  B.init(L/2,L/2); 

  double v0=sqrt(T);
  double x0,y0,xx,yy;
  int    find,failcount;

  for(int nn=0; nn<N; nn++){

    failcount=0;
    do{
      x0=r+(L-2.0*r)*drand48();  y0=r+(L-2.0*r)*drand48();  find=1;

      xx=B.x-x0; yy=B.y-y0;
      if(xx*xx+yy*yy<(rb+r)*(rb+r)){ failcount++; find=0; }

      for(int k=0; k<nn; k++){
        xx=P[k].x-x0; yy=P[k].y-y0;
        if(xx*xx+yy*yy<4.0*r*r){ failcount++; find=0; break;}
      }
      if(failcount>1000000){ break; }
    }while(!find);
    
    if(!find){ 
	fprintf(stderr,
         "can not find an initial state. Change N to %d\n",nn);
        N=nn; break; 
    } 

    P[nn].init(x0,y0,v0,2.0*M_PI*drand48());
    cell.add(nn);
  }     



  //=========  롼ν =================

  xi=0;
  t=0;        // ֤0ˤ롣

  plot(1);                 
}



/**********************************************************
             γҤƯ
**********************************************************/

double Force(double R){ 
  if(a<R){ 
     fprintf(stderr,"Error; potential barrier a*b is too small.\n"); 
     return  0; 
  }else if(R<0){
     fprintf(stderr,"Error; particles are not in contact.\n"); 
     return  0;
  }else{
     return b; 
  }
}

void interaction(void)
{
   int    i,j;
   double f,fx,fy,xx,yy,R2,R;
   void   actf(int,int); // ܿȽܿϤη׻ 


   //=========  ================

   B.fx=B.fy=0;
   for(int n=0; n<N; n++){  P[n].fx=-xi*P[n].vx;  P[n].fy=-xi*P[n].vy;  }


   for(int n=0; n<N; n++){
     //========= դγƱΤߺ ================
     int lyn=cell.Lj(P[n].y)-1, lyp=cell.Lj(P[n].y)+2;
     int lxn=cell.Li(P[n].x)-1, lxp=cell.Li(P[n].x)+2;

     for(int ly=lyn; ly<lyp; ly++)
       for(int lx=lxn; lx<lxp; lx++){
         i=lx; j=ly;
         if(i>=0 && i<M && j>=0 && j<M){
           for(int m=cell.first(i,j); m!=-1; m=cell.next())
             if(m>n){
                xx=P[n].x-P[m].x; yy=P[n].y-P[m].y; R2=xx*xx+yy*yy;
                if(R2<4.0*r*r){ //ܿƤ
                   R=sqrt(R2);
                   f=Force(r+r-R);
                   fx=f*xx/R;  fy=f*yy/R;
                   P[m].fx-=fx;      P[n].fx+=fx;
                   P[m].fy-=fy;      P[n].fy+=fy;
                }
             }
         }
       }

     //========= BrownγҤȼդγƱΤߺ ================
     xx=P[n].x-B.x; yy=P[n].y-B.y;  R2=xx*xx+yy*yy; 
     if(R2<(rb+r)*(rb+r)){ //ܿƤ
        R=sqrt(R2);
        f=Force(r+rb-R); 
        fx=f*xx/R; fy=f*yy/R;
        B.fx-=fx;      P[n].fx+=fx;
        B.fy-=fy;      P[n].fy+=fy;
     }
   }
}


/*******************************************************
             եå
********************************************************/

Simple_Window Win,TWin;
Control_Window CW,CWT(TWin);
Display  *d=Win.disp();
GC       gc0=graphic_context("lime green");
GC       gc1=graphic_context("red");
GC       gc2=graphic_context("skyblue");
GC       gc3=graphic_context("yellow green");
GC       white=graphic_context("white");
GC       black=graphic_context("black");
double   Tamp=0.5,mag;
int   width=700,Twidth=300,Theight=400,pr,pra,prb,prba,dispstep=200,show=0;

#define  TJ(y)  int(Theight*(1.0-Tamp*(y)))


void change_parameters(int)
{
  Control_Window PW;
  PW.realtime=0;  f_dialog close(PW);  close.title("close");  PW.realtime=1;
  PW.redraw();
  PW.title("parameters");

  PW<<PARAMETER
    <<a<<"a"<<b<<"b"<<r<<"r"<<rb<<"rb"<<mb<<"mb"<<N0<<"N"<<Q<<"Q";
  while(!(PW.chev && close.chev)) checkevent(); 

  Win.clear();
}

void show_background(int){ show=!show;}


void plot(int reset)
{
  static int initial=-1, count=0, Ti=0, Tj0=0, Tbj0=0;
  static int *i=NULL,*j=NULL, ib, jb, showold;
  int        Tj,Tbj;

  if(initial<0){
    mag=double(width)/L;
    CW.title("control panel");
    CW<<t<<"t"<<init<<"initial"<<change_parameters<<"parameter"
      <<PARAMETER<<dt<<"dt"<<Tamp<<"Tamp"<<dispstep<<"dispstep";

    CWT<<PARAMETER<<T<<"T";

    Win.geometry(width,width)<<"snapshot"<<show_background;
    TWin.geometry(Twidth,Theight)<<"temerature";
    initialize();     
    initial=0;
  }

  if(reset){
    Win.clear();
    if(i!=NULL){ delete [] i; } i=new int [N]; 
    if(j!=NULL){ delete [] j; } j=new int [N]; 

    pr=int(mag*r);        
    pra=int(mag*(r-a));   if(pra<1){ pra=1;}
    prb=int(mag*rb);      
    prba=int(mag*(rb-a)); if(prba<1){ prba=1;}
  }
  
  checkevent();

  if(count%dispstep==0){

    XFillArc(d,Win,white,ib-prb,jb-prb,2*prb,2*prb,0,23040);
    ib=int(mag*(B.x));
    jb=int(mag*(L-B.y));
    XFillArc(d,Win,gc3,ib-prb,jb-prb,2*prb,2*prb,0,23040);
    XFillArc(d,Win,gc0,ib-prba,jb-prba,2*prba,2*prba,0,23040);

    if(showold){
      for(int n=0; n<N; n++)
        XFillArc(d,Win,white,i[n]-pr,j[n]-pr,2*pr,2*pr,0,23040);
    }

    if(show){
      for(int n=0; n<N; n++){
        i[n]=int(mag*P[n].x);
        j[n]=int(mag*(L-P[n].y));
        XFillArc(d,Win,gc2,i[n]-pr,j[n]-pr,2*pr,2*pr,0,23040);
       }
     }
     showold=show;
    
    Tj=TJ(K);
    Tbj=TJ(0.5*mb*(B.vx*B.vx+B.vy*B.vy));
    XDrawLine(d,TWin,gc1,Ti,Tj0,Ti+1,Tj);
    XDrawLine(d,TWin,gc0,Ti,Tbj0,Ti+1,Tbj);
    Tj0=Tj;     
    Tbj0=Tbj;     
    Ti++; if(Ti>Twidth){TWin.clear(); Ti=0;}

    count=0;
  }

  count++;
}
