/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

          class T Ѥ Lattice

 =================================================================

++++  class T ˤϰʲΥСɬ ++++++

class T{    
     int    i,j,n;    // ʻֹ¸뤿ѿ
   public:
     double x,y;      // ɸ
     inline void set(int ii, int jj,int nn){ i=ii; j=jj; n=nn;}  
     inline int Li(){ return i; }
     inline int Lj(){ return j; }
     inline int Ln(){ return n; }
 }

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

#ifndef CELL_H
#define CELL_H

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <math.h>
#include <XRS/Array.h>

#define MAX(x,y)  ((x)>(y)?(x):(y))
#define MIN(x,y)  ((x)<(y)?(x):(y))

template <class T> class Lattice
{  
private:
  T           *P;                      // ϿγҤ        
  double      xmax,xmin,zmin,zmax,ax,ay;  // ϰ
  int         imax,jmax;               // ʻ礭
  int         ***p;                    // γֹΣ
  int         **psize;                 // p[i][j]Υ
  int         ii,jj,nn;      

  void        del_array();             // Υβ 
  void        new_array();             // Υγ

public:
  Lattice():p(NULL),psize(NULL){}
  ~Lattice(){ del_array(); }
 
  void    init(T*,double,double,double,double,int,int);  //ʻҥ  
  void    remove(int);                 // γҤ򥻥뤫
  int     add(int);                    // γҤΥѹ
  int     number(int,int);             // ʻҤ˴ޤޤγҿ֤
  int     first(int i,int j);          // ǽγҤ֤
  int     next();                      // γҤ֤ 

  inline int Li(double x){  return int(ax*(x-xmin)); }
  inline int Lj(double y){  return int(ay*(y-zmin)); }
  void    save(FILE * =stdout);
};                        



/*==============================================================
                 Υβ 
================================================================*/

template <class T> void Lattice<T>::del_array()
{ 
   if(p!=NULL){
     if(psize!=NULL){
       for(int i=0; i<imax; i++)
         for(int j=0; j<jmax; j++)
            if(psize[i][j]){ delete [] p[i][j]; p[i][j]=NULL; psize[i][j]=0;}
       delete_array(psize);  psize=NULL;
     }
     delete_array(p); p=NULL;
   }
}


/*===============================================================  
                  Υγ 
=================================================================*/

template <class T> void Lattice<T>::new_array()
{
   del_array();
   array(psize,imax,jmax);
   array(p,imax,jmax);
   for(int i=0; i<imax; i++)
      for(int j=0; j<jmax; j++){ psize[i][j]=0; p[i][j]=(int *)NULL; }
}


/*===============================================================  
                  ʻҥ
=================================================================*/

template <class T> void Lattice<T>::init(T* PP,double x1,double x2,double z1,double z2,int i,int j)
{  
   del_array();
   P=PP;
   xmin=MIN(x1,x2);  xmax=MAX(x1,x2);
   zmin=MIN(z1,z2);  zmax=MAX(z1,z2);
   if(i!=0 && j!=0 ){ imax=i; jmax=j;}
   else{ fprintf(stderr,"ERROR:  i or j ==0 in Lattice::init().\n"); exit(1);}
   ax=double(imax)/(xmax-xmin);
   ay=double(jmax)/(zmax-zmin);
   new_array();
}

/*===============================================================  
                  γҤ򥻥Ͽ
=================================================================*/

template <class T> int Lattice<T>::add(int v){    
   int i0=P[v].Li(), j0=P[v].Lj(), n0=P[v].Ln();
   int i=Li(P[v].x), j=Lj(P[v].y);

   if(i0==i && j0==j) return n0;
  
   if(i0>=0 && j0>=0 && n0>=0 && i0<imax && j0<jmax){
      if(n0<psize[i0][j0] && p[i0][j0][n0]==v){
          p[i0][j0][n0]=-1;   P[v].set(-1,-1,-1);
      }
   }else{
      P[v].set(-1,-1,-1); return -1;  
   }

   for(int n=0; n<psize[i][j]; n++)
      if(p[i][j][n]==-1)
          { p[i][j][n]=v; P[v].set(i,j,n); return n; }

   psize[i][j]++;  int *p2=new int [psize[i][j]];
   for(int n=0; n<psize[i][j]-1; n++) p2[n]=p[i][j][n];        
   p2[psize[i][j]-1]=v;        

   if(p[i][j]!=(int *)NULL){ delete [] p[i][j]; p[i][j]=(int *)NULL;}
   p[i][j]=p2;
     
   P[v].set(i,j,psize[i][j]-1);  return psize[i][j]-1;    
}


/*===============================================================  
                  γҤ򥻥뤫
=================================================================*/

template <class T> void Lattice<T>::remove(int v)
{     
  int i=P[v].Li(), j=P[v].Lj(), n=P[v].Ln();
   if(i>=0 && j>=0 && n>=0 && i<imax && j<jmax)
      if(n<psize[i][j] && p[i][j][n]==v){
          p[i][j][n]=-1;   P[v].set(-1,-1,-1);
      }
}


/*===============================================================  
              ʻ i,j ˴ޤޤγҤθĿ
=================================================================*/

template <class T> int  Lattice<T>::number(int i, int j)
{
    if(i<0 || i>imax-1 || j<0 || j>jmax-1) return 0;
    else{
      int k=0;
      for(int n=0; n<psize[i][j]; n++) if(p[i][j][n]!=-1) k++;
      return k;
    }
}               


/*===============================================================  
              ʻ i,j ˴ޤޤǽγ
=================================================================*/

template <class T> int Lattice<T>::first(int i,int j)
{         
    if(i<0 || i>imax-1 || j<0 || j>jmax-1)
       return -1;
    else{ 
       ii=i; jj=j; nn=0;  
       for(; nn<psize[ii][jj]; nn++)
         if(p[ii][jj][nn]!=-1) return p[ii][jj][nn]; 
       return -1;
    }
}


/*===============================================================  
              ʻ i,j ˴ޤޤ뼡γ
=================================================================*/

template <class T> int Lattice<T>::next()
{
   while(++nn<psize[ii][jj])
      if(p[ii][jj][nn]!=-1) return p[ii][jj][nn]; 
    return -1;
}


/*====================================================================
                ǡfileؤνФ 
======================================================================*/

template <class T> void Lattice<T>::save(FILE *file)
{ 
  if(file!=NULL) 
    for(int i=0; i<imax; i++)
      for(int j=0; j<jmax; j++)
        if(psize[i][j]>0){
         fprintf(file,"%d %d %d",i,j,psize[i][j]);
         for(int n=0; n<psize[i][j]; n++) fprintf(file," %d:%d",n,p[i][j][n]);
         fprintf(file,"\n");
	}
}

#undef MAX
#undef MIN

#endif  /**** CELL_H *****/








